<?php

define('NBC_NEWS_PATH' , PHPWG_PLUGINS_PATH.basename(dirname(__FILE__)).'/');
include_once(NBC_NEWS_PATH.'include/constants.php');


function plugin_install()
{
  $q = '
    INSERT INTO '.CONFIG_TABLE.' (param,value,comment)
    VALUES ("nbc_News","3;10;5,10,25,50;","Parametres nbc_News");
  ';

  pwg_query($q);

  $q = '
    CREATE TABLE '.NEWS_TABLE.' (
      id smallint(5) unsigned NOT NULL auto_increment,
      date datetime NOT NULL default \'0000-00-00 00:00:00\',
      author varchar(255) default NULL,
      status enum(\'public\',\'private\') NOT NULL default \'public\',
      PRIMARY KEY (id)
    ) ENGINE=MyISAM;
  ';
  pwg_query($q);

  $q = '
    insert into phpwebgallery_news values (1, \'2008-01-01 12:00:00\', \'Nicco\', \'public\');
  ';
  pwg_query($q);

  $q = '
    CREATE TABLE '.NEWS_GROUP_ACCESS_TABLE.' (
      group_id smallint(5) unsigned NOT NULL default \'0\',
      new_id smallint(5) unsigned NOT NULL default \'0\',
      PRIMARY KEY (group_id, new_id)
    ) ENGINE=MyISAM;
  ';
  pwg_query($q);
  
  $q = '
    CREATE TABLE '.NEWS_GROUP_REFUSED_TABLE.' (
      group_id smallint(5) unsigned NOT NULL default \'0\',
      new_id smallint(5) unsigned NOT NULL default \'0\',
      PRIMARY KEY (group_id, new_id)
    ) ENGINE=MyISAM;
  ';
  pwg_query($q);



  $q = '
    CREATE TABLE '.NEWS_TRANSLATION_TABLE.' (
      id smallint(6) unsigned NOT NULL auto_increment,
      new_id smallint(5) unsigned NOT NULL default \'0\',
      language varchar(50) NOT NULL default \'fr_FR.iso-8859-1\',
      title varchar(150) default NULL,
      content longtext ,
      PRIMARY KEY (id)
    ) ENGINE=MyISAM;
  ';
  pwg_query($q);
  
  $q = '
    insert  into '.NEWS_TRANSLATION_TABLE.' values 
      (1, 1, \'fr_FR.iso-8859-1\', \'Systeme de News PWG installe\', \'Felicitation ! Le systeme de News pour PWG a ete installe !\'),
      (2, 1, \'en_UK.iso-8859-1\', \'PWG News system installed\', \'Congratulation ! The news system for PWG has been installed !\');
  ';
  pwg_query($q);

  $q = '
    CREATE TABLE '.NEWS_USER_ACCESS_TABLE.' (
      user_id smallint(5) NOT NULL,
      new_id smallint(5) NOT NULL
    ) ENGINE=MyISAM;
  ';
  pwg_query($q);
  
  $q = '
    CREATE TABLE '.NEWS_USER_REFUSED_TABLE.' (
      user_id smallint(5) NOT NULL,
      new_id smallint(5) NOT NULL
    ) ENGINE=MyISAM;
  ';
  pwg_query($q);

}

function plugin_deactivate()
{
  @unlink( PHPWG_ROOT_PATH.'news.php' );
}

function plugin_uninstall()
{
  global $conf;

  if (isset($conf['nbc_News']))
  {
    $q = '
      DELETE FROM '.CONFIG_TABLE.'
      WHERE param="nbc_News" LIMIT 1;
    ';

    pwg_query($q);
  }

  $q = 'DROP TABLE '.NEWS_TABLE.'_SAV';
  pwg_query($q);
  
  $q = 'DROP TABLE '.NEWS_GROUP_ACCESS_TABLE.'_SAV';
  pwg_query($q);
  
  $q = 'DROP TABLE '.NEWS_GROUP_REFUSED_TABLE.'_SAV';
  pwg_query($q);

  $q = 'DROP TABLE '.NEWS_TRANSLATION_TABLE.'_SAV';
  pwg_query($q);
  
  $q = 'DROP TABLE '.NEWS_USER_ACCESS_TABLE.'_SAV';
  pwg_query($q);
  
  $q = 'DROP TABLE '.NEWS_USER_REFUSED_TABLE.'_SAV';
  pwg_query($q);



  $q = 'CREATE TABLE '.NEWS_TABLE.'_SAV AS SELECT * FROM '.NEWS_TABLE.'';
  pwg_query($q);
  
  $q = 'CREATE TABLE '.NEWS_GROUP_ACCESS_TABLE.'_SAV AS SELECT * FROM '.NEWS_GROUP_ACCESS_TABLE.'';
  pwg_query($q);
  
  $q = 'CREATE TABLE '.NEWS_GROUP_REFUSED_TABLE.'_SAV AS SELECT * FROM '.NEWS_GROUP_REFUSED_TABLE.'';
  pwg_query($q);

  $q = 'CREATE TABLE '.NEWS_TRANSLATION_TABLE.'_SAV AS SELECT * FROM '.NEWS_TRANSLATION_TABLE.'';
  pwg_query($q);
  
  $q = 'CREATE TABLE '.NEWS_USER_ACCESS_TABLE.'_SAV AS SELECT * FROM '.NEWS_USER_ACCESS_TABLE.'';
  pwg_query($q);
  
  $q = 'CREATE TABLE '.NEWS_USER_REFUSED_TABLE.'_SAV AS SELECT * FROM '.NEWS_USER_REFUSED_TABLE.'';
  pwg_query($q);



  $q = 'DROP TABLE '.NEWS_TABLE.'';
  pwg_query($q);
  
  $q = 'DROP TABLE '.NEWS_GROUP_ACCESS_TABLE.'';
  pwg_query($q);
  
  $q = 'DROP TABLE '.NEWS_GROUP_REFUSED_TABLE.'';
  pwg_query($q);

  $q = 'DROP TABLE '.NEWS_TRANSLATION_TABLE.'';
  pwg_query($q);
  
  $q = 'DROP TABLE '.NEWS_USER_ACCESS_TABLE.'';
  pwg_query($q);
  
  $q = 'DROP TABLE '.NEWS_USER_REFUSED_TABLE.'';
  pwg_query($q);
  
  @unlink( dirname(__FILE__).'/_nbcnews_config.dat' );
}

function plugin_activate()
{
  $dir_name = basename( dirname(__FILE__) );
  $c = <<<EOD
<?php
define('PHPWG_ROOT_PATH','./');
include_once( PHPWG_ROOT_PATH. 'plugins/$dir_name/news.php');
?>
EOD;
  $fp = fopen( PHPWG_ROOT_PATH.'news.php', 'w' );
  fwrite( $fp, $c);
  fclose( $fp );
}

?>
